

Application create: #EnvCluster with:
        (#( ToolCluster)
            collect: [:each | Smalltalk at: each ifAbsent: [
                self error: 'Not all of the prerequisites are loaded']])!

EnvCluster becomeDefault!
Application subclass: #EnvCluster
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

EnvCluster becomeDefault!
TmObject subclass: #Environment
    instanceVariableNames: 'desktop toolClassLister materialLister toolCol toolClassCol materialCol materialClassCol classManager '
    classVariableNames: ''
    poolDictionaries: ''!

EnvCluster becomeDefault!

!Environment class publicMethods !

new
	^super new initialize! !


!Environment publicMethods !

addTool: aTool
	aTool realize.
	toolCol add: aTool.
!

createTool: toolClass

	self addTool: ( toolClass new ).!

desktop
	^desktop!

initDesktop
	| anIndexCol |

	anIndexCol := ( self toolClassCol ) collect: [ :class |
		ListableWrapper new: class ].
	anIndexCol do: [ :aw |
		aw listNameBlock: [ :tc | tc toolName ] ].

 	toolClassLister := Lister new.
	toolClassLister toolName: 'Werkzeugklassen'.
	self addTool: toolClassLister.
	toolClassLister material: anIndexCol.
	toolClassLister fPart addDependent: self.

	materialLister := Lister new.
	materialLister toolName: 'Materialien'.
	self addTool: materialLister.
	materialLister material: ( self materialCol ).
	materialLister fPart addDependent: self.
!

initialize

	classManager := TmClassManager new.
	TmObject classManager: classManager.

	self initToolClassCol.
	toolCol := IndexableWrapper new: ( OrderedCollection new ).

	self initMaterialClassCol.
	self initMaterialCol.

	self initDesktop.
	toolClassLister realize.
	materialLister realize.
!

initMaterialClassCol

	materialClassCol := IndexableWrapper new: ( OrderedCollection new ).
	Material getClassCol: materialClassCol byClause: ( PropClause new: false ).
	
!

initMaterialCol
	| aFolder |

	materialCol := IndexableWrapper new: ( SortedCollection new ).

	materialCol add: ( Document new: 'GenDoc 4' ).
	materialCol add: ( Document new: 'GenDoc 7' ).
	materialCol add: ( Document new: 'GenDoc 11' ).
	materialCol add: ( Document new: 'GenDoc 42' ).

	materialCol add: ( SimpleDocument new: 'SimpleDoc 1' ).
	materialCol add: ( SimpleDocument new: 'SimpleDoc 2' ).
	materialCol add: ( SimpleDocument new: 'SimpleDoc 3' ).
	materialCol add: ( SimpleDocument new: 'SimpleDoc 5' ).
	materialCol add: ( SimpleDocument new: 'SimpleDoc 7' ).

	aFolder := Folder new: 'Folder 1'.
	aFolder add: ( Document new: 'FolderDoc 11' ).
	aFolder add: ( Document new: 'FolderDoc 13' ).
	aFolder add: ( Document new: 'FolderDoc 17' ).

	materialCol add: aFolder.

	aFolder := Folder new: 'Folder 2'.
	aFolder add: ( SimpleDocument new: 'FDoc XZX' ).
	aFolder add: ( SimpleDocument new: 'FolderDoc YXZ' ).
	aFolder add: ( SimpleDocument new: 'FolderDoc ZYX' ).
	aFolder add: ( SimpleDocument new: 'doc' ).

	materialCol add: aFolder.!

initToolClassCol

	toolClassCol := IndexableWrapper new: ( OrderedCollection new ).
	Tool getClassCol: toolClassCol byClause: ( PropClause new: false ).
!

materialClassCol
	^materialClassCol!

materialCol
	^materialCol!

removeTool: aTool!

startupMaterial: aMaterial
	| aTool |

	( aMaterial isKindOf: Folder )
	ifTrue: [
		( aMaterial title = 'Folder 1' ) ifTrue: [
			aTool := Lister new. ] ifFalse: [
			aTool := SimpleBrowser new. ].
		aTool material: aMaterial.
		^self addTool: aTool. ].

	( aMaterial isKindOf: SimpleDocument )
	ifTrue: [
		aTool := SimpleEditor new.
		aTool material: aMaterial.
		^self addTool: aTool. ].
!

toolClassCol
	^toolClassCol!

toolCol
	^toolCol!

update: aSymbol from: anObject

	( aSymbol == #cEvItemSelected ) & ( anObject == ( toolClassLister fPart ) ) ifTrue: [
		^self createTool: ( toolClassLister fPart selectedItem wrappedObject ) ].

	( aSymbol == #cEvItemSelected ) & ( anObject == ( materialLister fPart ) ) ifTrue: [
		^self startupMaterial: ( materialLister fPart selectedItem ) ].

	super update: aSymbol from: anObject.
! !

